const fs = require('fs');
const { uniqBy, flatten } = require('lodash');

const rows = fs
  .readFileSync('./address.txt', { encoding: 'utf-8' })
  .split('\n')
  .map((row) => row.split('\t'))
  .filter((x) => x.includes('존재'))
  .filter((x) => {
    const [시도, 시군구, 시군구또는동, 동] = x[1].split(' ');
    return typeof 시군구또는동 !== 'undefined';
  });

const dictionary = {};

const jsonRows = rows
  .filter((row) => {
    const [시도, 시군구, 시군구또는동, 동] = row[1].split(' ');
    return !!시군구또는동;
  })
  .map((row) => {
    const [시도, 시군구, 시군구또는동, 동] = row[1].split(' ');
    const 코드 = row[0];
    const 시군구코드 = 코드.slice(0, 5);

    if (시군구) {
      dictionary[`${시군구코드}`] = uniqBy(dictionary[`${시군구코드}`] ? dictionary[`${시군구코드}`].concat([{ 코드, 동: 동 ?? 시군구또는동 }]) : [{ 코드, 동: 동 ?? 시군구또는동 }], (x) => x.동);
    }
  });

const updateQueries = flatten(
  Object.entries(dictionary).map(([시군구코드, 동과코드목록]) => {
    return uniqBy(동과코드목록, ({ 동, 코드 }) => 동).map(({ 동, 코드 }) => {
      return `await queryRunner.query('INSERT INTO area (code, name, parent_area_id) values ("${코드}", "${동}", (SELECT area_id from area as area_temp where code = "${시군구코드}"))');`;
    });
  }),
);

fs.writeFileSync('./dong.json', JSON.stringify(dictionary), { encoding: 'utf8' });
fs.writeFileSync('./dong-query.txt', updateQueries.join('\n'), { encoding: 'utf8' });
